import type { ExtensionAuto } from '../core';
import { BehaviorPresetOptions } from '../extensions/behavior';
import { EditorModeKeymapOptions } from '../extensions/behavior/EditorModeKeymap';
import { FullPresetOptions } from '../presets/full';
import type { DirectiveSyntaxContext } from '../utils/directive';
import type { FileUploadHandler } from '../utils/upload';
import type { MarkdownEditorPreset } from './types';
export declare type ExtensionsOptions = BehaviorPresetOptions & FullPresetOptions;
export declare type BundlePresetOptions = ExtensionsOptions & EditorModeKeymapOptions & {
    preset: MarkdownEditorPreset;
    mdBreaks?: boolean;
    fileUploadHandler?: FileUploadHandler;
    /**
     * If we need to set dimensions for uploaded images
     *
     * @default false
     */
    needToSetDimensionsForUploadedImages?: boolean;
    enableNewImageSizeCalculation?: boolean;
    directiveSyntax: DirectiveSyntaxContext;
};
declare global {
    namespace WysiwygEditor {
        interface Context {
            directiveSyntax: DirectiveSyntaxContext;
        }
    }
}
export declare const BundlePreset: ExtensionAuto<BundlePresetOptions>;
