"use strict";
var _DirectiveSyntaxContext_option;
Object.defineProperty(exports, "__esModule", { value: true });
exports.DirectiveSyntaxContext = void 0;
const tslib_1 = require("tslib");
const DIRECTIVE_SYNTAX_DEFAULT = 'disabled';
class DirectiveSyntaxContext {
    constructor(option) {
        _DirectiveSyntaxContext_option.set(this, void 0);
        this.option = option;
        tslib_1.__classPrivateFieldSet(this, _DirectiveSyntaxContext_option, this.option, "f");
    }
    set option(value) {
        tslib_1.__classPrivateFieldSet(this, _DirectiveSyntaxContext_option, value !== null && value !== void 0 ? value : DIRECTIVE_SYNTAX_DEFAULT, "f");
    }
    get option() {
        return tslib_1.__classPrivateFieldGet(this, _DirectiveSyntaxContext_option, "f");
    }
    valueFor(key) {
        let value;
        if (typeof this.option === 'object')
            value = this.option[key];
        if (typeof this.option === 'string')
            value = this.option;
        return value !== null && value !== void 0 ? value : DIRECTIVE_SYNTAX_DEFAULT;
    }
    mdPluginValueFor(key) {
        const value = this.valueFor(key);
        return value === 'preserve' || value === 'overwrite' ? 'enabled' : value;
    }
    /** helper for wisywig serializer */
    shouldSerializeToDirective(key, tokenMarkup) {
        const option = this.valueFor(key);
        if (option === 'overwrite' || option === 'only')
            return true;
        if (typeof tokenMarkup === 'string') {
            if (tokenMarkup.startsWith(':'))
                return true;
            if (tokenMarkup.startsWith('{'))
                return false;
        }
        if (option === 'preserve')
            return true;
        return false;
    }
    /** helper for markup-mode commands and actions */
    shouldInsertDirectiveMarkup(key) {
        const value = this.valueFor(key);
        if (value === 'disabled' || value === 'enabled')
            return false;
        return true;
    }
}
exports.DirectiveSyntaxContext = DirectiveSyntaxContext;
_DirectiveSyntaxContext_option = new WeakMap();
