import { CodeEditor } from '../../markup/editor';
import { ToolbarData } from '../../toolbar/Toolbar';
import { ToolbarGroupData } from '../../toolbar/ToolbarGroup';
import { ToolbarListButtonData } from '../../toolbar/ToolbarListButton';
import { ToolbarButtonPopupData, ToolbarItemData, ToolbarListButtonItemData, ToolbarListItemData, ToolbarReactComponentData, ToolbarSingleItemData } from '../../toolbar/types';
import type { MarkdownEditorPreset } from '../types';
export declare type MToolbarData = ToolbarData<CodeEditor>;
export declare type MToolbarItemData = ToolbarItemData<CodeEditor>;
export declare type MToolbarSingleItemData = ToolbarSingleItemData<CodeEditor>;
export declare type MToolbarGroupData = ToolbarGroupData<CodeEditor>;
export declare type MToolbarReactComponentData = ToolbarReactComponentData<CodeEditor>;
export declare type MToolbarListButtonData = ToolbarListButtonData<CodeEditor>;
export declare type MToolbarListItemData = ToolbarListItemData<CodeEditor>;
export declare type MToolbarButtonPopupData = ToolbarButtonPopupData<CodeEditor>;
export declare const mUndoItemData: MToolbarSingleItemData;
export declare const mRedoItemData: MToolbarSingleItemData;
export declare const mBoldItemData: MToolbarSingleItemData;
export declare const mItalicItemData: MToolbarSingleItemData;
export declare const mUnderlineItemData: MToolbarSingleItemData;
export declare const mStrikethroughItemData: MToolbarSingleItemData;
export declare const mMonospaceItemData: MToolbarSingleItemData;
export declare const mMarkedItemData: MToolbarSingleItemData;
export declare const mCheckboxButton: MToolbarSingleItemData;
export declare const mCheckboxItemData: MToolbarSingleItemData;
export declare const mLinkButton: MToolbarSingleItemData;
export declare const mLinkItemData: MToolbarSingleItemData;
export declare const mQuoteButton: MToolbarSingleItemData;
export declare const mQuoteItemData: MToolbarSingleItemData;
export declare const mCutButton: MToolbarSingleItemData;
export declare const mCutItemData: MToolbarSingleItemData;
export declare const mNoteButton: MToolbarSingleItemData;
export declare const mNoteItemData: MToolbarSingleItemData;
export declare const mTableButton: MToolbarSingleItemData;
export declare const mTableItemData: MToolbarSingleItemData;
export declare const mCodeItemData: ToolbarListButtonItemData<CodeEditor>;
export declare const mImagePopupData: MToolbarButtonPopupData;
export declare const mImageItemData: MToolbarButtonPopupData;
export declare const mFilePopupData: MToolbarButtonPopupData;
export declare const mFileItemData: MToolbarButtonPopupData;
export declare const mTabsItemData: MToolbarSingleItemData;
export declare const mMathInlineItemData: ToolbarListButtonItemData<CodeEditor>;
export declare const mMathBlockItemData: ToolbarListButtonItemData<CodeEditor>;
export declare const mYfmHtmlBlockButton: MToolbarSingleItemData;
export declare const mYfmHtmlBlockItemData: MToolbarSingleItemData;
export declare const mMermaidButton: MToolbarSingleItemData;
export declare const mMermaidItemData: MToolbarSingleItemData;
export declare const mCodeblockItemData: MToolbarItemData;
export declare const mCodeBlockItemData: MToolbarItemData;
export declare const mHruleItemData: MToolbarSingleItemData;
export declare const mEmojiItemData: MToolbarSingleItemData;
export declare const mMathListItem: MToolbarListItemData;
export declare const mHeading1ItemData: ToolbarListButtonItemData<CodeEditor>;
export declare const mHeading2ItemData: ToolbarListButtonItemData<CodeEditor>;
export declare const mHeading3ItemData: ToolbarListButtonItemData<CodeEditor>;
export declare const mHeading4ItemData: ToolbarListButtonItemData<CodeEditor>;
export declare const mHeading5ItemData: ToolbarListButtonItemData<CodeEditor>;
export declare const mHeading6ItemData: ToolbarListButtonItemData<CodeEditor>;
export declare const mBulletListItemData: ToolbarListButtonItemData<CodeEditor>;
export declare const mOrderedListItemData: ToolbarListButtonItemData<CodeEditor>;
export declare const mSinkListItemData: ToolbarListButtonItemData<CodeEditor>;
export declare const mLiftListItemData: ToolbarListButtonItemData<CodeEditor>;
export declare const mHeadingListConfig: MToolbarListButtonData;
export declare const mListsListConfig: MToolbarListButtonData;
export declare const mListMoveListConfig: MToolbarListButtonData;
export declare const mCodeListConfig: MToolbarListButtonData;
export declare const mMathListConfig: MToolbarListButtonData;
export declare const mHiddenData: MToolbarSingleItemData[];
export declare const mHistoryGroupConfig: MToolbarGroupData;
export declare const mBiusGroupConfig: MToolbarGroupData;
export declare const mToolbarConfig: MToolbarData;
export declare const mToolbarConfigByPreset: Record<MarkdownEditorPreset, MToolbarData>;
export declare const mHiddenDataByPreset: Record<MarkdownEditorPreset, MToolbarItemData[]>;
