import { autocompletion } from '@codemirror/autocomplete';
import type { Extension, StateCommand } from '@codemirror/state';
import { EditorView, type EditorViewConfig, KeyBinding, placeholder } from '@codemirror/view';
import type { ParseInsertedUrlAsImage } from '../../bundle';
import type { EventMap } from '../../bundle/Editor';
import type { ReactRenderStorage } from '../../extensions';
import type { Receiver } from '../../utils';
import type { DirectiveSyntaxContext } from '../../utils/directive';
import { type FileUploadHandler } from './files-upload-facet';
import { type YfmLangOptions } from './yfm';
export type { YfmLangOptions };
declare type Autocompletion = Parameters<typeof autocompletion>[0];
export declare type CreateCodemirrorParams = {
    doc: EditorViewConfig['doc'];
    placeholder: Parameters<typeof placeholder>[0];
    onCancel: () => void;
    onSubmit: () => void;
    onChange: () => void;
    onDocChange: () => void;
    onScroll: (event: Event) => void;
    reactRenderer: ReactRenderStorage;
    uploadHandler?: FileUploadHandler;
    parseHtmlOnPaste?: boolean;
    parseInsertedUrlAsImage?: ParseInsertedUrlAsImage;
    needImageDimensions?: boolean;
    enableNewImageSizeCalculation?: boolean;
    extensions?: Extension[];
    disabledExtensions?: {
        history?: boolean;
    };
    keymaps?: readonly KeyBinding[];
    receiver?: Receiver<EventMap>;
    yfmLangOptions?: YfmLangOptions;
    autocompletion?: Autocompletion;
    directiveSyntax: DirectiveSyntaxContext;
};
export declare function createCodemirror(params: CreateCodemirrorParams): EditorView;
export declare function withLogger(action: string, command: StateCommand): StateCommand;
